// AplTransportClientTCP.cpp : Defines the initialization routines for the DLL.
//

#include "stdafx.h"
#include <afxdllx.h>
#include <aplSocketTransport.h>
#include "resource.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif


static AFX_EXTENSION_MODULE AplTransportClientTCPDLL = { NULL, NULL };

HINSTANCE module_inst = 0;
//Происходит ли в данный момент поиск имени файла
HANDLE IsEventFileCreateProcessed;

// счетчик запущенных клиентских сеансов
CaplLog m_MainLog;
CImageList imagelist;
CImageList imagelist_exclam;

extern "C" int APIENTRY
DllMain(HINSTANCE hInstance, DWORD dwReason, LPVOID lpReserved)
{
	module_inst=hInstance;
	// Remove this if you use lpReserved
	UNREFERENCED_PARAMETER(lpReserved);
	AfxInitRichEdit();

	//SetModuleLogFileName("C:\\Program Files\\PSS\\client.log");

	if (dwReason == DLL_PROCESS_ATTACH)
	{
		TRACE0("APLTRANSPORTCLIENTTCP.DLL Initializing!\n");
		
		// Extension DLL one-time initialization
		if (!AfxInitExtensionModule(AplTransportClientTCPDLL, hInstance))
			return 0;
		if (!AfxSocketInit())
		{
			AfxMessageBox(_T("Windows sockets initialization failed."));
			return 0;
		}
//		AfxSetResourceHandle( hInstance );
		
		// Insert this DLL into the resource chain
		// NOTE: If this Extension DLL is being implicitly linked to by
		//  an MFC Regular DLL (such as an ActiveX Control)
		//  instead of an MFC application, then you will want to
		//  remove this line from DllMain and put it in a separate
		//  function exported from this Extension DLL.  The Regular DLL
		//  that uses this Extension DLL should then explicitly call that
		//  function to initialize this Extension DLL.  Otherwise,
		//  the CDynLinkLibrary object will not be attached to the
		//  Regular DLL's resource chain, and serious problems will
		//  result.

		new CDynLinkLibrary(AplTransportClientTCPDLL);
		//Происходит ли в данный момент поиск имени файла? нет
		IsEventFileCreateProcessed = CreateEvent(0, false, true, _T("AplClient{C4E2265D-CEEA-479b-A2DF-F33EA6ACE81C}"));
		imagelist.Create(IDR_TOOLBAR_TREE,20,2,RGB(255,0,255));
		imagelist_exclam.Create(IDR_TOOLBAR_EXCLAM,6,2,RGB(255,0,255));
	}
	else if (dwReason == DLL_PROCESS_DETACH)
	{
		TRACE0("APLTRANSPORTCLIENTTCP.DLL Terminating!\n");
		// Terminate the library before destructors are called
		AfxTermExtensionModule(AplTransportClientTCPDLL);
		CloseHandle(IsEventFileCreateProcessed);
	}
	return 1;   // ok
}
